--[[
   Copyright (c) The OpenRA Developers and Contributors
   This file is part of OpenRA, which is free software. It is made
   available to you under the terms of the GNU General Public License
   as published by the Free Software Foundation, either version 3 of
   the License, or (at your option) any later version. For more
   information, see COPYING.
]]
ActiveHeroes = {}
PlayableUnits = {"dog","e1","e1r1","e2","e3","e3r1","e4","medi","mech","shok","e7"}
PlayableRides = {"jeep","harv","v2rl","1tnk","2tnk","3tnk","4tnk","arty","mnly","mgg","mrj","ttnk","ftrk","dtrk","ctnk","qtnk","yak","mig","heli","hind","mh60","ss","msub","dd","ca","pt"}
PlayableAll = {}

StartRenegade = false

EmptyCheckDone = false
RespawnCheckDone = false
RenegadeCheckDone = false
CheckedDeaths = false
Waittobeseated = false

CenterCamera = function()
	Queuenumber = 0
	AlliedWaiters = 0
	SovietWaiters = 0
	for h,Heroes in pairs (ActiveHeroes) do
		if Heroes.Owner.Team == 1 then
		AlliedWaiters = AlliedWaiters+1
		end
		if Heroes.Owner.Team == 2 then
		SovietWaiters = SovietWaiters+1
		end
	end
	MoreNeeded = ""
	
	AllTeamPlayers = #Alliedorder - 1
	LegalUnits = #Ally.GetActorsByTypes(PlayableUnits)
	MoreNeeded = " [Infantry Pool: " .. LegalUnits.. "]"
	if AlliedWaiters < AllTeamPlayers and LegalUnits == 0 then
		MoreNeeded = " [More Infantry needed!]"
	end
	if Ally.IsLocalPlayer == true then
		UserInterface.SetMissionText("[Living Renegades: " .. AlliedWaiters .."/"..AllTeamPlayers.."]" .. MoreNeeded, Ally.Color)
	end
	
	AllTeamPlayers = #Sovietorder - 1
	LegalUnits = #Soviet.GetActorsByTypes(PlayableUnits)
	MoreNeeded = " [Infantry Pool: " .. LegalUnits.. "]"
	if SovietWaiters < AllTeamPlayers and LegalUnits == 0  then
		MoreNeeded = " [More Infantry needed!]"
	end
	if Soviet.IsLocalPlayer == true then
		UserInterface.SetMissionText("[Living Renegades: " .. SovietWaiters .."/"..AllTeamPlayers.."]" .. MoreNeeded, Soviet.Color)
	end
	for i,PID in pairs (Playerorder) do
		if PID.Team == 1 then
			ShownMoney = AllyMoney
		end
		if PID.Team == 2 then
			ShownMoney = SovietMoney
		end
			
		PlayerUnits = PID.GetActorsByTypes(PlayableAll)
		if #PlayerUnits > 0 then
			Ammocounter = ""
			if PlayerUnits[1].HasProperty("AmmoCount") == true then
				Ammocounter = " [Ammo: " .. PlayerUnits[1].AmmoCount("primary") .. "/" .. PlayerUnits[1].MaximumAmmoCount("primary") .. "]"
			end
			if PID.IsLocalPlayer == true then
				UserInterface.SetMissionText("[Unit Type: " .. PlayerUnits[1].TooltipName .. "] [Health: " .. PlayerUnits[1].Health .. "/" .. PlayerUnits[1].MaxHealth .. "]".. Ammocounter .. " [CO Money: " .. ShownMoney .. "$]", PID.Color)
				Camera.Position = PlayerUnits[1].CenterPosition
			end
		end
		if #PlayerUnits == 0 then
			for o, POI in ipairs(Playerorder) do
				if POI.Team == PID.Team then
					Queuenumber = Queuenumber + 1
				end
				if POI == PID and PID.IsLocalPlayer == true then
					UserInterface.SetMissionText("[Your CO has no Infantry left, please wait.]" .. " [CO Money: " .. ShownMoney .. "$]", PID.Color)
				end
			end
		end
	end
end

RenegadeChecker = function(KilledHero)
	local Ownerid = KilledHero.Owner
	local Ownercolor = KilledHero.Color
	local Playername = KilledHero.Name
	Media.DisplayMessage("Reincarnation upcoming...", Playername .. " has died.", Ownercolor)
	for i,FindHero in pairs (ActiveHeroes) do
		if FindHero.Owner == Ownerid then
			table.remove(ActiveHeroes, i)
		end
	end
end

				--[[else if Ownerid.IsLocalPlayer == true then
					UserInterface.SetMissionText("Unit Type: " .. Heroes.TooltipName .. " Health: " .. Heroes.Health .. "/" .. Heroes.MaxHealth, Ownercolor)
				end]]--

GiveBackEmpty = function(Transporter)
	Transporter.Stop()
--		Empties.Health = Empties.Health - 1
--		if Empties.Type == "jeep" and Empties.Owner == Empty and Empties.IsDead == false then
	Giveback = Actor.Create (Transporter.Type, true, { Location = Transporter.Location, Owner = Greece })
	Giveback.Health = Transporter.Health
	Transporter.Destroy()
--		end
end

RenegadeUnit = function()
	if RespawnCheckDone == false then
		RespawnCheckDone = true
		for i,PID in pairs (Playerorder) do
			if PID ~= Ally and PID ~= Soviet then
				table.remove(Playerorder, i)
				table.insert(Playerorder, PID)
				CurrentHero = 0
				for h,Heroes in pairs (ActiveHeroes) do
					if ActiveHeroes[h].Owner == PID then
						CurrentHero = CurrentHero+1
					end		
				end
			if StartRenegade == true and CurrentHero == 0 and Waittobeseated == false then
				Waittobeseated = true
				if PID.Team == 1 then
					LegalUnits = Ally.GetActorsByTypes(PlayableUnits)
				end
				if PID.Team == 2 then
					LegalUnits = Soviet.GetActorsByTypes(PlayableUnits)
				end
				if #LegalUnits > 0 then
					--table.remove(Playerorder, i)
					--table.insert(Playerorder, PID)
					RNG = Utils.RandomInteger(1, #LegalUnits)				
					LegalUnits[RNG].Owner = PID
					table.insert(ActiveHeroes, LegalUnits[RNG])
					LegalUnits[RNG].GiveLevels(4)
					local Unitname = LegalUnits[RNG].TooltipName
					local Ownerid = PID
					local Ownercolor = PID.Color
					local Playername = PID.Name
					Beacon.New(PID,LegalUnits[RNG].CenterPosition,5,true)
					Trigger.OnKilled(LegalUnits[RNG],function(Actor)
						local Ownerid = Actor.Owner
						local Ownercolor = Ownerid.Color
						local Playername = Ownerid.Name
						if PID.Team == LocalPlayer.Team then
							Media.DisplayMessage("Waiting for Reincarnation...", Playername .. " has died.", Ownercolor)
						end
						for h,Heroes in pairs (ActiveHeroes) do
							if Actor == Heroes then
								table.remove(ActiveHeroes, h)
							end
						end
					end)
					if PID.Team == LocalPlayer.Team then
						Media.DisplayMessage("Good Luck!", Playername .. " is now a " .. Unitname, Ownercolor)
					end
				end
				Trigger.AfterDelay(DateTime.Seconds(0.75), function()
					Waittobeseated = false
				end)
			end
		end
	end
	Trigger.AfterDelay(DateTime.Seconds(0.75), function()
		RespawnCheckDone = false
		end)
	end
end

ListAllPlayables = function()
	for _, value in ipairs(PlayableUnits) do
        table.insert(PlayableAll, value)
    end
	for _, value in ipairs(PlayableRides) do
        table.insert(PlayableAll, value)
    end
end

GiveTransporters = function()
	if EmptyCheckDone == false then
		EmptyCheckDone = true
		for c,CoP in pairs (CoPlayers) do
			AllTrans = CoP.GetActorsByTypes(PlayableRides)
			for i,Transporter in pairs (AllTrans) do
				if Transporter.HasPassengers == true and Transporter.Owner == CoP then
					FirstCargo = Transporter.Passengers[1]
					if FirstCargo.Owner ~= CoP then
						Transporter.Owner = FirstCargo.Owner
						Transporter.GiveLevels(4)
						Trigger.OnPassengerExited(Transporter, function()
							Transporter.Owner = Neutral
							Transporter.Stop()
							EmptyType = Transporter.Type
							EmptyLocation = Transporter.Location
							EmptyHealth = Transporter.Health
							EmptyFacing = Transporter.Facing
							if Transporter.HasProperty("AmmoCount") == true then
							EmptyAmmo = Transporter.AmmoCount("primary")
							end
							Transporter.IsInWorld = false
							Transporter.Destroy()
							Giveback = Actor.Create (EmptyType, true, { Location = EmptyLocation, Owner = CoP, Facing = EmptyFacing })
							Giveback.Health = EmptyHealth
							if Giveback.HasProperty("AmmoCount") == true then
							Giveback.Reload("primary",(Giveback.MaximumAmmoCount("primary")*-1)+EmptyAmmo)
							end
						end)
					end
				end
			end
		end
		Trigger.AfterDelay(DateTime.Seconds(0.25), function()
			EmptyCheckDone = false
		end)
	end
end

DomeCheck = function()
	AllyCODomes = Ally.GetActorsByType("dome")
	SovietCODomes = Soviet.GetActorsByType("dome")
	AllyMoney = Ally.Cash + Ally.Resources
	SovietMoney = Soviet.Cash + Soviet.Resources
	for i,PID in pairs (Playerorder) do
		DomeCount = 0
		if PID.Team == 1 then
			for d,RenDo in pairs (AlliedRenDomes) do
				if RenDo.Owner == PID then
					DomeCount = DomeCount+1
				end
			end
		end
		
		if PID.Team == 2 then
			for d,RenDo in pairs (SovietRenDomes) do
				if RenDo.Owner == PID then
					DomeCount = DomeCount+1
				end
			end
		end
		
		if PID.Team == 1 and #AllyCODomes > 0 and DomeCount == 0 then
			Newdome = Actor.Create ("rendome", false, { Location = CPos.Zero, Owner = PID })
			table.insert(AlliedRenDomes, Newdome)
		end
			
		if PID.Team == 2 and #SovietCODomes > 0 and DomeCount == 0 then
			Newdome = Actor.Create ("rendome", false, { Location = CPos.Zero, Owner = PID })
			table.insert(SovietRenDomes, Newdome)
		end
	end
	
	if #AllyCODomes == 0 then
		for y,RenDest in pairs (AlliedRenDomes) do
			RenDest.Kill ()
			table.remove(AlliedRenDomes, y)
		end
	end
			
	if #SovietCODomes == 0 then
		for y,RenDest in pairs (SovietRenDomes) do
			RenDest.Kill ()
			table.remove(SovietRenDomes, y)
		end
	end
end

Tick = function()
	DomeCheck()
	RenegadeUnit()
	GiveTransporters()
	CenterCamera()
	if  Ally.HasNoRequiredUnits () and DateTime.GameTime > DateTime.Seconds(5) then
		for i,Def in pairs (AlliedDefeaters) do
			if Def.IsDead == false then
			Def.Kill()
			end
		end
	end
	if  Soviet.HasNoRequiredUnits () and DateTime.GameTime > DateTime.Seconds(5) then
		for i,Def in pairs (SovietDefeaters) do
			if Def.IsDead == false then
			Def.Kill()
			end
		end
	end
end

WorldLoaded = function()
	Ally = Player.GetPlayer("Ally")
	EmptyAlly = Player.GetPlayer("EmptyAlly")
	AlliedRen1 = Player.GetPlayer("AlliedRen1")
	AlliedRen2 = Player.GetPlayer("AlliedRen2")
	AlliedRen3 = Player.GetPlayer("AlliedRen3")
	AlliedRen4 = Player.GetPlayer("AlliedRen4")
	AlliedRen5 = Player.GetPlayer("AlliedRen5")
	AlliedRen6 = Player.GetPlayer("AlliedRen6")
	AlliedRen7 = Player.GetPlayer("AlliedRen7")
	AlliedRen8 = Player.GetPlayer("AlliedRen8")
	AlliedRen9 = Player.GetPlayer("AlliedRen9")
	AlliedRen10 = Player.GetPlayer("AlliedRen10")
	AlliedRen11 = Player.GetPlayer("AlliedRen11")
	AlliedRen12 = Player.GetPlayer("AlliedRen12")
	AlliedRen13 = Player.GetPlayer("AlliedRen13")
	AlliedRen14 = Player.GetPlayer("AlliedRen14")
	AlliedRen15 = Player.GetPlayer("AlliedRen15")
	AlliedRen16 = Player.GetPlayer("AlliedRen16")
	Soviet = Player.GetPlayer("Soviet")
	EmptySoviet = Player.GetPlayer("EmptySoviet")
	SovietRen1 = Player.GetPlayer("SovietRen1")
	SovietRen2 = Player.GetPlayer("SovietRen2")
	SovietRen3 = Player.GetPlayer("SovietRen3")
	SovietRen4 = Player.GetPlayer("SovietRen4")
	SovietRen5 = Player.GetPlayer("SovietRen5")
	SovietRen6 = Player.GetPlayer("SovietRen6")
	SovietRen7 = Player.GetPlayer("SovietRen7")
	SovietRen8 = Player.GetPlayer("SovietRen8")
	SovietRen9 = Player.GetPlayer("SovietRen9")
	SovietRen10 = Player.GetPlayer("SovietRen10")
	SovietRen11 = Player.GetPlayer("SovietRen11")
	SovietRen12 = Player.GetPlayer("SovietRen12")
	SovietRen13 = Player.GetPlayer("SovietRen13")
	SovietRen14 = Player.GetPlayer("SovietRen14")
	SovietRen15 = Player.GetPlayer("SovietRen15")
	SovietRen16 = Player.GetPlayer("SovietRen16")
	Neutral = Player.GetPlayer("Neutral")

	CoPlayers = {}
	ListAllPlayables()
	
	AlliedRenDomes = {}
	SovietRenDomes = {}

	AlliedPlayers = {};
	if AlliedRen1 ~= nil then
	table.insert(AlliedPlayers, AlliedRen1)
	end
	if AlliedRen2 ~= nil then
	table.insert(AlliedPlayers, AlliedRen2)
	end
	if AlliedRen3 ~= nil then
	table.insert(AlliedPlayers, AlliedRen3)
	end
	if AlliedRen4 ~= nil then
	table.insert(AlliedPlayers, AlliedRen4)
	end
	if AlliedRen5 ~= nil then
	table.insert(AlliedPlayers, AlliedRen5)
	end
	if AlliedRen6 ~= nil then
	table.insert(AlliedPlayers, AlliedRen6)
	end
	if AlliedRen7 ~= nil then
	table.insert(AlliedPlayers, AlliedRen7)
	end
	if AlliedRen8 ~= nil then
	table.insert(AlliedPlayers, AlliedRen8)
	end
	if AlliedRen9 ~= nil then
	table.insert(AlliedPlayers, AlliedRen9)
	end
	if AlliedRen10 ~= nil then
	table.insert(AlliedPlayers, AlliedRen10)
	end
	if AlliedRen11 ~= nil then
	table.insert(AlliedPlayers, AlliedRen11)
	end
	if AlliedRen12 ~= nil then
	table.insert(AlliedPlayers, AlliedRen12)
	end
	if AlliedRen13 ~= nil then
	table.insert(AlliedPlayers, AlliedRen13)
	end
	if AlliedRen14 ~= nil then
	table.insert(AlliedPlayers, AlliedRen14)
	end
	if AlliedRen15 ~= nil then
	table.insert(AlliedPlayers, AlliedRen15)
	end
	if AlliedRen16 ~= nil then
	table.insert(AlliedPlayers, AlliedRen16)
	end
	table.insert(AlliedPlayers, Ally)
	table.insert(CoPlayers, Ally)
	
	SovietPlayers = {};
	if SovietRen1 ~= nil then
	table.insert(SovietPlayers, SovietRen1)
	end
	if SovietRen2 ~= nil then
	table.insert(SovietPlayers, SovietRen2)
	end
	if SovietRen3 ~= nil then
	table.insert(SovietPlayers, SovietRen3)
	end
	if SovietRen4 ~= nil then
	table.insert(SovietPlayers, SovietRen4)
	end
	if SovietRen5 ~= nil then
	table.insert(SovietPlayers, SovietRen5)
	end
	if SovietRen6 ~= nil then
	table.insert(SovietPlayers, SovietRen6)
	end
	if SovietRen7 ~= nil then
	table.insert(SovietPlayers, SovietRen7)
	end
	if SovietRen8 ~= nil then
	table.insert(SovietPlayers, SovietRen8)
	end
	if SovietRen9 ~= nil then
	table.insert(SovietPlayers, SovietRen9)
	end
	if SovietRen10 ~= nil then
	table.insert(SovietPlayers, SovietRen10)
	end
	if SovietRen11 ~= nil then
	table.insert(SovietPlayers, SovietRen11)
	end
	if SovietRen12 ~= nil then
	table.insert(SovietPlayers, SovietRen12)
	end
	if SovietRen13 ~= nil then
	table.insert(SovietPlayers, SovietRen13)
	end
	if SovietRen14 ~= nil then
	table.insert(SovietPlayers, SovietRen14)
	end
	if SovietRen15 ~= nil then
	table.insert(SovietPlayers, SovietRen15)
	end
	if SovietRen16 ~= nil then
	table.insert(SovietPlayers, SovietRen16)
	end
	table.insert(SovietPlayers, Soviet)
	table.insert(CoPlayers, Soviet)
	
	Alliedorder = AlliedPlayers
	Sovietorder = SovietPlayers
	
	table.remove(Alliedorder, 0)
	table.remove(Sovietorder, 0)
	
	AllPlayers = {}
	for _, value in ipairs(AlliedPlayers) do
		if value.IsLocalPlayer == true then
		Camera.Position = AlliedSpawn.CenterPosition
        end
		table.insert(AllPlayers, value)
    end
	for _, value in ipairs(SovietPlayers) do
		if value.IsLocalPlayer == true then
		Camera.Position = SovietSpawn.CenterPosition
        end
		table.insert(AllPlayers, value)
    end

	Playerorder = {}
	for _, value in ipairs(Alliedorder) do
		if value ~= Ally then
		value.Cash = 0
		table.insert(Playerorder, value)
		end
	end
	for _, value in ipairs(Sovietorder) do
		if value ~= Soviet then
		value.Cash = 0
		table.insert(Playerorder, value)
		end
    end
	
	LocalPlayer = Ally
	for i,PID in pairs (AllPlayers) do
		if PID.IsLocalPlayer == true and PID.IsNonCombatant == false then
			LocalPlayer = PID
		end
	end
		
	ConstructionVehicleReinforcements = { "mcv" }
	AlliedStart = { AlliedSpawn.Location, AlliedSpawn.Location }
	SovietStart = { SovietSpawn.Location, SovietSpawn.Location }
	Reinforcements.Reinforce(Ally, ConstructionVehicleReinforcements, AlliedStart)
	Reinforcements.Reinforce(Soviet, ConstructionVehicleReinforcements, SovietStart)
	Starterunit = "e1"
	AlliedDefeaters = {}
	SovietDefeaters = {}
	AlliedStartBarracks = Actor.Create ("tent", true, { Location = AlliedSpawn.Location+CVec.New(0,-3), Owner = Ally })
	AlliedStartBarracks = Actor.Create ("powr", true, { Location = AlliedSpawn.Location+CVec.New(2,-3), Owner = Ally })
	for i,PID in pairs (AlliedPlayers) do
	if PID ~= Ally then
	AlliedStartUnit = Actor.Create (Starterunit, true, { Location = AlliedSpawn.Location, Owner = Ally })
	AlliedDefeater = Actor.Create ("defeater", false, { Location = CPos.Zero, Owner = PID })
	table.insert(AlliedDefeaters, AlliedDefeater)
	AlliedStartUnit.Scatter()
	end
	end
	SovietStartBarracks = Actor.Create ("barr", true, { Location = SovietSpawn.Location+CVec.New(0,-3), Owner = Soviet })
	SovietStartBarracks = Actor.Create ("powr", true, { Location = SovietSpawn.Location+CVec.New(-2,-3), Owner = Soviet })
	for i,PID in pairs (SovietPlayers) do
	if PID ~= Soviet then
	SovietStartUnit = Actor.Create (Starterunit, true, { Location = SovietSpawn.Location, Owner = Soviet })
	SovietDefeater = Actor.Create ("defeater", false, { Location = CPos.Zero, Owner = PID })
	table.insert(SovietDefeaters, SovietDefeater)
	SovietStartUnit.Scatter()
	end
	end
	
	--[[
	for i,Rides in pairs (PlayableRides) do
	DebugUnit = Actor.Create (Rides, true, { Location = AlliedSpawn.Location, Owner = Ally })
	if DebugUnit.HasProperty("Scatter") == true then
	DebugUnit.Scatter()
	end
	end
	]]--
	
	ListAllPlayables()
	StartRenegade = true

end
